//
export {version as visualizeVersion} from './package.json';
//
// Data layer
export {default as DataFrame} from './src/data/dataframe';
export {default as DataStore} from './src/data/store';
export {default as dataSources} from './src/data/sources';
export {default as dataEvents} from './src/data/events';
//export {default as dataLocale} from './src/data/locale';

//
//  Core API
export {visuals} from './src/core/base';
export {default as createChart} from './src/core/chart';
export {default as createPaper, Svg, Div} from './src/core/paper';
export {default as visualTransform} from './src/transforms/base';
export {default as visualTransforms} from './src/transforms/index';
//
//  Components
export {default as visualComponents} from './src/components/index';

// utilities
export {colorScales} from './src/plugins/color';
export {default as pyramid} from './src/transforms/pyramid';
export {default as niceRange} from './src/utils/nicerange';
//
//  Charts
//  =========
//
//  Last import, important!
export {default as Visual} from './src/core/visual';
export {default as BarChart} from './src/charts/bar';
export {default as LineChart} from './src/charts/line';
export {default as AreaChart} from './src/charts/area';
export {default as PieChart} from './src/charts/pie';
export {default as PyramidChart} from './src/charts/pyramid';
export {default as Treemap} from './src/charts/treemap';
export {default as TextChart} from './src/charts/text';
export {default as Heatmap} from './src/charts/heatmap';
export {default as GeoChart} from './src/charts/geo';
export {default as Tabular} from './src/charts/tabular';
export {default as createCompositeChart} from './src/charts/composite';
